<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class PMBperfectmoney
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_PERFECTMONEY_ERR_VENDOR' );
    $vendor_name=trim($params->get('perfectmoney_user'));
    $password_missing=JText::_( 'PMB_PERFECTMONEY_ERR_PASSWORD' );
    $vendor_password=trim($params->get('perfectmoney_password'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }
    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('perfectmoney_trans_cost')+0;
    $percent_per_transaction=$params->get('perfectmoney_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('perfectmoney_user'));
    $vendor_password=trim($params->get('perfectmoney_password'));
    
    $mode='LIVE';
    $currency=$params->get('perfectmoney_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'PerfectMoney');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'PerfectMoney');
    
    $success_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/perfectmoney_return.php");
    $failure_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/perfectmoney_failure.php");
    $notify_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/perfectmoney_notify.php");
    
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $pmb_button='Redirecting to payment page';
    $config =& JFactory::getConfig();
    $post_variables=array(
    "PAYMENT_ID"=>$details['order_id'],
    "PAYEE_ACCOUNT"=>$vendor_name,
    "PAYEE_NAME"=>$config->getValue( 'config.sitename' ),
    "PAYMENT_AMOUNT"=>$payment,
    "PAYMENT_UNITS"=>$currency,
    "STATUS_URL"=>'mailto:'.$config->getValue( 'config.mailfrom' ),
    "PAYMENT_URL"=>$success_url,
    "STATUS_URL"=>$notify_url,
    "NOPAYMENT_URL"=>$failure_url,
    "BAGGAGE_FIELDS"=>'PRODUCT',
    "PRODUCT"=>$PaymentDescription
    );
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="https://perfectmoney.is/api/step1.asp" method="post">';
    foreach ($post_variables as $name => $value) {
			$html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
?>