<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class PMBplationline
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_PLATIONLINE_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_PLATIONLINE_MODULE_ERR_ENC_KEY' );
    $password2_missing=JText::_( 'PMB_PLATIONLINE_MODULE_ERR_ENC_MODE' );
    $vendor_name=trim($params->get('plationline_user'));
    $vendor_password=trim($params->get('plationline_enc_key'));
    $vendor_password2=trim($params->get('plationline_enc_mode'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password2=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password2_missing;?></div>
      <?php
      return false;
    }
    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('plationline_trans_cost')+0;
    $percent_per_transaction=$params->get('plationline_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('plationline_user'));
    $vendor_password=trim($params->get('plationline_enc_key'));
    $vendor_password2=trim($params->get('plationline_enc_mode'));
    $language=$params->get('plationline_language');
    $mode=$params->get('plationline_mode');
    $currency=$params->get('plationline_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'PlatiOnline');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'PlatiOnline');
    
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $my_class = new platiOnlineHelper();
		$my_class->HostName = 'https://secure2.plationline.ro/';
		$my_class->LoginID = $vendor_name;
		$my_class->KeyEnc = $vendor_password;
		$my_class->KeyMod = $vendor_password2;

		$my_class->amount = $payment;
		$my_class->currency = $currency;
		$my_class->OrderNumber = $details['order_id'];
		$my_class->action = "2"; // Cod Autentificare si Autorizare conform anexa F

		$rez = $my_class->InsertHash_Auth();
    $lang=$language;
		$coscump = "<start_string>";
		$coscump .= "<item>";
		$coscump .= "<ProdID>".$details['order_id']."</ProdID>";
		$coscump .= "<qty>1</qty>";
		$coscump .= "<itemprice>".$payment."</itemprice>";
		$coscump .= "<name>".$PaymentDescription."</name>";
		$coscump .= "<period></period>"; // Neimplementat de PO
		$coscump .= "<rec_id></rec_id>"; // Neimplementat de PO
		$coscump .= "<description></description>";
		$coscump .= "<pimg></pimg>"; // Neimplementat de PO
		$coscump .= "<rec_price></rec_price>"; // Neimplementat de PO
		$coscump .= "<vat>0</vat>";
		$coscump .= "<lang_id>".$lang."</lang_id>";
		$coscump .= "<stamp>".date("m d Y h:i:s a")."</stamp>";
		$coscump .= "<on_stoc>1</on_stoc>";
		$coscump .= "<prodtype_id>1</prodtype_id>";
		$coscump .= "<categ_id></categ_id>"; // Neimplementat de PO
		$coscump .= "<merchLoginID></merchLoginID>"; // Neimplementat de PO
		$coscump .= "</item>";

		$coscump .= "<coupon>";
		$coscump .= "<key></key>";
		$coscump .= "<value></value>";
		$coscump .= "<percent></percent>";
		$coscump .= "<workingname></workingname>";
		$coscump .= "<type></type>";
		$coscump .= "<scop></scop>";
		$coscump .= "</coupon>";
		$coscump .= "<shipping>";
		$coscump .= "<type>0</type>"; //de modificat daca implementam mai multe modalitati de transport
		$coscump .= "<price>0</price>";
		$coscump .= "<vat>0</vat>";
		$coscump .= "<pimg></pimg>";
		$coscump .= "</shipping>";
    
		$coscump .="</start_string>";
    $post_variables = Array(
			"F_Order_String" => $coscump,
			"F_Message" => $rez["F_Message"],
			"F_Crypt_Message" => $rez["F_Crypt_Message"],
			"F_Action" => $rez["F_Action"],
			"F_Show_Form" => "1",
			"F_Login" => $my_class->LoginID,
			"F_Action" => $my_class->action,
			"F_Lang" => $lang,     // de modificat daca adaugam mai multe limbi in magazin
			"F_Amount" => $payment,
			"F_Currency" => $currency,
			"F_Order_Number" => $details['order_id'],
			"F_First_Name" => $details['BillFname'],
			"F_Last_Name" => $details['BillLname'],
			"F_Address" => $details['BillAddr'],
			"F_Zip" => $details['BillZip'],
			"F_City" => $details['BillCity'],
			"F_State" => $details['BillState'],
			"F_Country" => $details['BillCountry'],
			"F_Email" => $details['BillEmail'],
			"F_Phone" => $details['BillPhone'],
			
			"F_Ship_To_First_name" => $details['BillFname'],
			"F_Ship_To_Last_name" => $details['BillLname'],
			"F_Ship_To_Address" => $details['BillAddr'],
			"F_Ship_To_City" => $details['BillCity'],
			"F_Ship_To_State" => $details['BillState'],
			"F_Ship_To_Zipcode" => $details['BillZip'],
			"F_Ship_To_Country" =>  $details['BillCountry'],
		);
		if($mode == 'TEST'){
			$post_variables["F_Test_Request"]=1;
		}
    
    $url = $my_class->HostName;
    
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$url.'" method="post">';
	  foreach( $post_variables as $name => $value ) {
			$html.= '<input type="hidden" name="'.$name.'" value="'.htmlspecialchars($value).'" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
class platiOnlineHelper{

	public  $KeyEnc=null;
	public  $KeyMod=null;
	public  $LoginID=null;
	public  $amount=null;
	public  $currency=null;
	public  $OrderNumber=null;
	public  $action=null;
	public  $TransID=null;
	public  $shipping=null;
	public  $awb=null;
	public  $ret;
	public  $version="3.0.3";
	public $rates;
	var $strMult;
	var $sTemp;
	var $sAsci;
	var $iAsci;
	var $decSt;

	var $rep;
	var $hex;
	var $tot;
	var $encSt;
	

	function PO3(){
		$this->version="3.0.3";
	}
  function generate_random_letters($length) {
    $random = '';
    for ($i = 0; $i < $length; $i++) {
      $random .= chr(rand(ord('a'), ord('z')));
    }
    return $random;
  }
	function Mult($x){
		$y=1;
		$pg=$this->KeyEnc;
		$m=$this->KeyMod;
		while ($pg > 0){
			while (($pg / 2)==intval($pg / 2)){
				$x=$this->nMod(($x*$x),$m);
				$pg=$pg / 2;			
			}
			$y=$this->nMod(($x*$y),$m);
			$pg=$pg-1;
		}
		return ($y);
	}

	function nMod($x,$y){
		$bInt=0;
		if($y==0){
			return;
		};
		$bInt=$x-(intval($x/$y)*$y);	
		return($bInt);
	}

	////////////////// GCEncode/////////////////////////
	//metoda de codificare pe baza cheilor
	////////////////////////////////////////////////////
	function GCEncode($tIp){
		$this->encSt ="";
		for($z=0;$z < strlen($tIp);$z++){
			$this->sTemp = substr($tIp,$z,1);
			$this->sAsci = ord($this->sTemp);
			$this->iAsci = intval($this->sAsci);			
			$this->encSt=$this->encSt.$this->NumberToHex($this->Mult($this->iAsci),8);
		}
		return strtoupper($this->encSt);
	}


	////////////////// NumberToHex////////////////////////////
	//metoda de conversie a unui numar din zecimal in hexa 
	//////////////////////////////////////////////////////////
	function NumberToHex($pLngNumber,$pLngLength){
		$this->rep = str_repeat("0",$pLngLength);	
		$this->hex = dechex($pLngNumber);
		$this->tot = $this->rep.$this->hex;	
		return(substr($this->tot,strlen($this->tot) - $pLngLength,strlen($this->tot)));
	}


	////////////////// HexToNumber/////////////////////////
	//metoda de conversie a unui numar hexa in zecimal
	///////////////////////////////////////////////////////
	function HexToNumber($pStrHex){
		$this->ret = intval(hexdec("&h".$pStrHex));	
		return($this->ret);
	}

	/////////////////// hex2str/////////////////////////
	//metoda de conversie a unui numar hexa in string
	////////////////////////////////////////////////////
	function hex2str($hex){
		$str="";
		for($i=0;$i<strlen($hex);$i+=2){
			$str.=chr(hexdec(substr($hex,$i,2)));
		}
		return $str;
	}


	//key is a hexadecimal number
	////////////////// POEncode/////////////////////////
	//metoda de codificare pe baza cheilor
	////////////////////////////////////////////////////
	function POEncode($key, $data) {
		$key=$this->hex2str($key);
		$blocksize=64;
		$hashfunc='sha1';
		if (strlen($key)>$blocksize)
		$key=pack('H*', $hashfunc($key));
		$key=str_pad($key, $blocksize, chr(0x00));
		$ipad=str_repeat(chr(0x36),$blocksize);
		$opad=str_repeat(chr(0x5c),$blocksize);
		$hmac = pack(
			'H*',$hashfunc(
				($key^$opad).pack(
					'H*',$hashfunc(
						($key^$ipad).$data
					)
				)
			)
		);
		return bin2hex($hmac);
	}

	////////////////// InsertHash /////////////////////////
	//metoda de codificare a mesajului - Cerere de Autorizare card
	////////////////////////////////////////////////////
	public function InsertHash_Auth(){
		$sequence = rand(1, 1000);
		$tstamp = date("m")."/".date("d")."/".date("Y")." ".date("h:i:s a");                         
		$msg = $sequence."^".$this->LoginID."^".$tstamp."^".$this->amount."^".$this->currency."^".$this->OrderNumber."^".$this->action;
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded= $this->POEncode($cheie, $stringRSA);
		$ret = Array("F_Message" => $msg,"F_Crypt_Message"=> $sEncoded,"F_Action"=>$this->action);
		return $ret;
	}

	////////////////// InsertHash /////////////////////////
	//metoda de codificare a mesajului - Cerere de Autorizare card RZB
	////////////////////////////////////////////////////
	public function InsertHash_AuthRate_RZB(){
		$sequence = rand(1, 1000);
		$tstamp = date("m")."/".date("d")."/".date("Y")." ".date("h:i:s a");                         
		$msg = $sequence."^".$this->LoginID."^".$tstamp."^".$this->amount."^".$this->currency."^".$this->OrderNumber."^".$this->action."^".$this->rates;
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded= $this->POEncode($cheie, $stringRSA);
		$ret = Array("F_Message" => $msg,"F_Crypt_Message"=> $sEncoded,"F_Action"=>$this->action);
		return $ret;
	}

	////////////////// InsertHash_Incasare/////////////////////////
	//metoda Cerere de incasare
	////////////////////////////////////////////////////////////////
	public function InsertHash_Incasare(){
		$sequence = rand(1, 1000);
		$tstamp = date("m")."/".date("d")."/".date("Y")." ".date("h:i:s a");                         
		$msg = $sequence."^".$this->LoginID."^".$tstamp."^".$this->TransID."^".$this->OrderNumber."^".$this->awb."^".$this->shipping."^".$this->action;
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded= $this->POEncode($cheie, $stringRSA);
		$ret = Array("F_Message" => $msg,"F_Crypt_Message"=> $sEncoded,"F_Action"=>$this->action);
		return $ret;
	}



	////////////////// InsertHash_Void//////////////////////////////
	//metoda de anulare
	////////////////////////////////////////////////////////////////
	public function InsertHash_Void(){
		$sequence = rand(1, 1000);
		$tstamp = date("m")."/".date("d")."/".date("Y")." ".date("h:i:s a");                         
		$msg = $sequence."^".$this->LoginID."^".$tstamp."^".$this->TransID."^".$this->OrderNumber."^".$this->action;
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded= $this->POEncode($cheie, $stringRSA);
		$ret = Array("F_Message" => $msg,"F_Crypt_Message"=> $sEncoded,"F_Action"=>$this->action);
		return $ret;
	}

	
	////////////////// InsertHash_Interog/////////////////////////
	//metoda de interogare
	////////////////////////////////////////////////////////////////
	public function InsertHash_Interog(){
		$sequence = rand(1, 1000);
		$tstamp = date("m")."/".date("d")."/".date("Y")." ".date("h:i:s a");                         
		$msg = $sequence."^".$this->LoginID."^".$tstamp."^".$this->TransID."^".$this->OrderNumber."^".$this->action;
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded= $this->POEncode($cheie, $stringRSA);
		$ret = Array("F_Message" => $msg,"F_Crypt_Message"=> $sEncoded,"F_Action"=>$this->action);
		return $ret;
	}


	////////////////// InsertHash_Credit/////////////////////////
	//metoda de creditare
	////////////////////////////////////////////////////////////////
	public function InsertHash_Credit(){
		$sequence = rand(1, 1000);
		$tstamp = date("m")."/".date("d")."/".date("Y")." ".date("h:i:s a");                         
		$msg = $sequence."^".$this->LoginID."^".$tstamp."^".$this->TransID."^".$this->OrderNumber."^".$this->amount."^".$this->action;
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded= $this->POEncode($cheie, $stringRSA);
		$ret = Array("F_Message" => $msg,"F_Crypt_Message"=> $sEncoded,"F_Action"=>$this->action);
		return $ret;
	}

	public function VerifyFRM($msg){
		$stringRSA=$this->GCEncode(strval($msg));
		$cheie = strval($this->KeyEnc).strval($this->KeyMod);
		$sEncoded=$this->POEncode($cheie, $stringRSA);
		return $sEncoded;
	}
}
?>